/*-
 * Copyright (c) 2003,2004 Yuriy Tsibizov
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer
 *    in this position and unchanged.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: emu10kx-ioctl.h,v 1.21 2005/10/13 18:20:01 chibis Exp $
 * $FreeBSD$
 */

#if 0
struct emu10kx_dsp_ctl {
	int source[3];
	int amount[3];
	int destination;
};
#endif

struct emu10kx_mixer_ctl {
	int volume[4];
	int page;
	int connector;
	int channels_used;
	char desc[64];
};


struct emu10kx_mixer_page {
	int page;
	int playback_controls;
	int recording_controls;
	char desc[64];
};

struct emu10kx_peek {
	unsigned int voice;
	unsigned int addr;
	uint32_t code[2];
};
struct emu10kx_params {
	unsigned int mchannel_fx;
	unsigned int dsp_zero;
	unsigned int code_base;
	unsigned int code_size;
	unsigned int gpr_base;
	unsigned int num_gprs;
	unsigned int input_base;
	unsigned int output_base;
	unsigned int opcode_shift;
	unsigned int high_operand_shift;
	uint32_t is_emu10k1:1, is_emu10k2, is_ca0151:1, is_ca0108:1,
	         has_ac97:1, has_51:1, has_71:1,
		 enable_ir:1, enable_debug:1,
	         broken_digital:1;
	unsigned int num_g;
	uint32_t iocfg;
	uint32_t a_iocfg;
};
#define E10GETPAGECOUNT _IOR('P', 1, struct emu10kx_mixer_page)
#define E10GETPAGEINFO _IOWR('P', 2, struct emu10kx_mixer_page)
#define E10GETMIXER	_IOWR('M', 10, struct emu10kx_mixer_ctl)
#define E10SETMIXER	_IOW('M', 11, struct emu10kx_mixer_ctl)
#define E10GETMODE	_IOR('M', 11, int)
#define E10SETMODE	_IOW('M', 12, int)
#define E10GETSPDIFMODE	_IOR('M', 13, int)
#define E10SETSPDIFMODE	_IOW('M', 14, int)
#define E10MIXERRESET	_IOW('M', 15, int)
#define E10MIXERAMPLIFY	_IOWR('M', 16, int)
#define E10ENABLEIR	_IOWR('I', 1, int)
#define E10PARAMS	_IOR('F', 1, struct emu10kx_params)
#define E10PEEKDSP	_IOWR('F', 2, struct emu10kx_peek)
#define E10PEEKGPR	_IOWR('F', 3, struct emu10kx_peek)
#define E10PEEKVOICE	_IOWR('F', 4, struct emu10kx_peek)
#define E10PEEKP16V	_IOWR('F', 5, struct emu10kx_peek)
#define E10POKEP16V	_IOWR('F', 6, struct emu10kx_peek)
#define E10DEBUG	_IOWR('D', 1, int)
